com.io7m.jstructural.core

## Class SSubsection

- java.lang.Object
- - com.io7m.jstructural.core.SSubsection

-     @Immutable
      public final class SSubsection
      extends Object

  A subsection.

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `equals(Object obj)`
    `SNonEmptyList<SSubsectionContent>` | `getContent()`
    `com.io7m.jaux.functional.Option<SID>` | `getID()`
    `SSubsectionTitle` | `getTitle()`
    `com.io7m.jaux.functional.Option<String>` | `getType()`
    `int` | `hashCode()`
    `static SSubsection` | `subsection(SSubsectionTitle in_title, SNonEmptyList<SSubsectionContent> in_content)` Create a subsection with the given title and content.
    `static SSubsection` | `subsectionID(SID id, SSubsectionTitle in_title, SNonEmptyList<SSubsectionContent> in_content)` Create a subsection with the given id, title, and content.
    `static SSubsection` | `subsectionTyped(String type, SSubsectionTitle in_title, SNonEmptyList<SSubsectionContent> in_content)` Create a subsection with the given type, title, and content.
    `static SSubsection` | `subsectionTypedID(String type, SID id, SSubsectionTitle in_title, SNonEmptyList<SSubsectionContent> in_content)` Create a subsection with the given type, id, title, and content.

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

- - ### Method Detail

    - #### subsection

          @Nonnull
          public static SSubsection subsection(@Nonnull
                                       SSubsectionTitle in_title,
                                       @Nonnull
                                       SNonEmptyList<SSubsectionContent> in_content)
                                        throws com.io7m.jaux.Constraints.ConstraintError

      Create a subsection with the given title and content.
      Parameters:
        `in_title` - The title
        `in_content` - The content
      Returns:
        A new subsection
      Throws:
        `com.io7m.jaux.Constraints.ConstraintError` - If any parameter is `null`

    - #### subsectionID

          @Nonnull
          public static SSubsection subsectionID(@Nonnull
                                         SID id,
                                         @Nonnull
                                         SSubsectionTitle in_title,
                                         @Nonnull
                                         SNonEmptyList<SSubsectionContent> in_content)
                                          throws com.io7m.jaux.Constraints.ConstraintError

      Create a subsection with the given id, title, and content.
      Parameters:
        `id` - The ID
        `in_title` - The title
        `in_content` - The content
      Returns:
        A new subsection
      Throws:
        `com.io7m.jaux.Constraints.ConstraintError` - If any parameter is `null`

    - #### subsectionTyped

          @Nonnull
          public static SSubsection subsectionTyped(@Nonnull
                                            String type,
                                            @Nonnull
                                            SSubsectionTitle in_title,
                                            @Nonnull
                                            SNonEmptyList<SSubsectionContent> in_content)
                                             throws com.io7m.jaux.Constraints.ConstraintError

      Create a subsection with the given type, title, and content.
      Parameters:
        `type` - The type
        `in_title` - The title
        `in_content` - The content
      Returns:
        A new subsection
      Throws:
        `com.io7m.jaux.Constraints.ConstraintError` - If any parameter is `null`

    - #### subsectionTypedID

          @Nonnull
          public static SSubsection subsectionTypedID(@Nonnull
                                              String type,
                                              @Nonnull
                                              SID id,
                                              @Nonnull
                                              SSubsectionTitle in_title,
                                              @Nonnull
                                              SNonEmptyList<SSubsectionContent> in_content)
                                               throws com.io7m.jaux.Constraints.ConstraintError

      Create a subsection with the given type, id, title, and content.
      Parameters:
        `type` - The type
        `id` - The ID
        `in_title` - The title
        `in_content` - The content
      Returns:
        A new subsection
      Throws:
        `com.io7m.jaux.Constraints.ConstraintError` - If any parameter is `null`

    - #### equals

          public boolean equals(Object obj)

      Overrides:
        `equals` in class `Object`

    - #### getContent

          @Nonnull
          public SNonEmptyList<SSubsectionContent> getContent()

      Returns:
        The subsection content

    - #### getID

          @Nonnull
          public com.io7m.jaux.functional.Option<SID> getID()

      Returns:
        The subsection ID

    - #### getTitle

          @Nonnull
          public SSubsectionTitle getTitle()

      Returns:
        The subsection title

    - #### getType

          @Nonnull
          public com.io7m.jaux.functional.Option<String> getType()

      Returns:
        The subsection type attribute

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `Object`

Copyright © 2014 <code@io7m.com> http://io7m.com